

    set A32Base [third [split $AddressData :]]


DefineRegister $Module xVME FirmwareRev   "-a $A32Base -w 32 -o 0x800c -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME GEO_Address   "-a $A32Base -w 32 -o 0x8008 -p ro -d 16 -l 5 -b 0 -z x"
DefineRegister $Module xVME Reset         "-a $A32Base -w 32 -o 0x800a -p wo -d 16 -l 0 -b 0"
DefineRegister $Module xVME VMEStatus     "-a $A32Base -w 32 -o 0xef04 -p ro -d 32 -l 3 -b 0 -z x"

DefineRegister $Module xVME ROM.OUI_MSB   "-a $A32Base -w 32 -o 0x8124 -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.OUI       "-a $A32Base -w 32 -o 0x8128 -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.OUI_LSB   "-a $A32Base -w 32 -o 0x812c -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.Version   "-a $A32Base -w 32 -o 0x8130 -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.BID_MSB   "-a $A32Base -w 32 -o 0x8134 -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.BID       "-a $A32Base -w 32 -o 0x8138 -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.BID_LSB   "-a $A32Base -w 32 -o 0x813c -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.Rev       "-a $A32Base -w 32 -o 0x804c -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.Ser_MSB   "-a $A32Base -w 32 -o 0x8180 -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.Ser_LSB   "-a $A32Base -w 32 -o 0x8184 -p ro -d 16 -l 0 -b 0 -z x"

DefineRegister $Module xVME UserConfig    "-a $A32Base -w 32 -o 0x8016 -p rw -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME UserFlashSel  "-a $A32Base -w 32 -o 0x8012 -p rw -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME UserFlashMem  "-a $A32Base -w 32 -o 0x8014 -p rw -d 16 -l 0 -b 0 -z x"

DefineRegister $Module xVME FlashData     "-a $A32Base -w 32 -o 0x8014 -p ro -d 16 -l 0 -b 0 -z x"

DefineRegister $Module xVME Scratch16     "-a $A32Base -w 32 -o 0x8018 -p rw -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME Arm           "-a $A32Base -w 32 -o 0x8018 -p rw -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME Scratch32     "-a $A32Base -w 32 -o 0x8020 -p rw -d 32 -l 0 -b 0 -z x"

DefineRegister $Module xVME DataItem      "-a $A32Base -w 32 -o 0x0 -p ro -d 32 -l 0 -b 0 -z x"
DefineRegister $Module bVME DataBuffer    "-a $A32Base -w 32 -o 0x0 -p ro -d 32 -z x -l 64"

DefineRegister $Module xVME GateWidth     "-a $A32Base -w 32 -o 0x1010 -p rw -d 32 -l 0 -b 0 -z d"
DefineRegister $Module xVME GateDelay     "-a $A32Base -w 32 -o 0x1014 -p rw -d 32 -l 0 -b 0 -z d"

DefineRegister $Module xVME Ctrl         "-a $A32Base -w 32 -o 0x1018 -p rw -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME Ctrl.B0      "-a $A32Base -w 32 -o 0x1018 -p rw -d 32 -l 1 -b 0 -z d"
DefineRegister $Module xVME Ctrl.B1      "-a $A32Base -w 32 -o 0x1018 -p rw -d 32 -l 1 -b 1 -z d"
DefineRegister $Module xVME Ctrl.B2      "-a $A32Base -w 32 -o 0x1018 -p rw -d 32 -l 1 -b 2 -z d"
DefineRegister $Module xVME Ctrl.B3      "-a $A32Base -w 32 -o 0x1018 -p rw -d 32 -l 1 -b 3 -z d"
DefineRegister $Module xVME Ctrl.B8      "-a $A32Base -w 32 -o 0x1018 -p rw -d 32 -l 1 -b 8 -z d"
DefineRegister $Module xVME Ctrl.B9      "-a $A32Base -w 32 -o 0x1018 -p rw -d 32 -l 1 -b 9 -z d"
DefineRegister $Module xVME Ctrl.B10     "-a $A32Base -w 32 -o 0x1018 -p rw -d 32 -l 1 -b 10 -z d"
DefineRegister $Module xVME Ctrl.B11     "-a $A32Base -w 32 -o 0x1018 -p rw -d 32 -l 1 -b 11 -z d"
DefineRegister $Module xVME Ctrl.B12     "-a $A32Base -w 32 -o 0x1018 -p rw -d 32 -l 1 -b 12 -z d"
DefineRegister $Module xVME Ctrl.B13     "-a $A32Base -w 32 -o 0x1018 -p rw -d 32 -l 1 -b 13 -z d"
DefineRegister $Module xVME Ctrl.B14     "-a $A32Base -w 32 -o 0x1018 -p rw -d 32 -l 1 -b 14 -z d"
DefineRegister $Module xVME Ctrl.B15     "-a $A32Base -w 32 -o 0x1018 -p rw -d 32 -l 1 -b 15 -z d"

DefineRegister $Module xVME RdOutCtrl    "-a $A32Base -w 32 -o 0x101c -p rw -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME RdOutCtrl.B0 "-a $A32Base -w 32 -o 0x101c -p rw -d 32 -l 1 -b 0 -z d"

DefineRegister $Module xVME TrigReqCnt   "-a $A32Base -w 32 -o 0x1030 -p ro -d 32 -l 0 -b 0 -z d"
DefineRegister $Module xVME TrigAccCnt   "-a $A32Base -w 32 -o 0x1034 -p ro -d 32 -l 0 -b 0 -z d"

DefineRegister $Module xVME RdOutStat    "-a $A32Base -w 32 -o 0x103c -p ro -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME RdOutStat.B0 "-a $A32Base -w 32 -o 0x103c -p ro -d 32 -l 1 -b 0 -z d"
DefineRegister $Module xVME RdOutStat.B1 "-a $A32Base -w 32 -o 0x103c -p ro -d 32 -l 1 -b 1 -z d"
DefineRegister $Module xVME RdOutStat.B2 "-a $A32Base -w 32 -o 0x103c -p ro -d 32 -l 1 -b 2 -z d"
DefineRegister $Module xVME RdOutStat.B3 "-a $A32Base -w 32 -o 0x103c -p ro -d 32 -l 1 -b 3 -z d"
DefineRegister $Module xVME RdOutStat.B4 "-a $A32Base -w 32 -o 0x103c -p ro -d 32 -l 1 -b 4 -z d"

DefineRegister $Module xVME FirmwareDate     "-a $A32Base -w 32 -o 0x1040 -p ro -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME FirmwareVersion  "-a $A32Base -w 32 -o 0x100c -p ro -d 32 -l 0 -b 0 -z x"



puts "Defined $Module"
