


#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag
     variable ModuleIndex

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

#     do_Select $ModuleIndex

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable allmodules 0


    variable IVec 0

    variable P0  "VMEIDXYC240   1"
    variable LR 0
    variable LG 0
    variable IE 0
    variable IP 0

    set Color1(0) Red
    set Color1(1) Green
    set Color2(0) Blue
    set Color2(1) #D4A017     ;# Orange Gold

  for {set j 0} {$j <= 7} {incr j} {variable II$j; set II$j 0}
  for {set j 0} {$j <= 7} {incr j} {variable IM$j; set IM$j 0}
  for {set j 0} {$j <= 7} {incr j} {variable IP$j; set IP$j 0}
  for {set j 0} {$j <= 7} {incr j} {variable IC$j; set IC$j 0}
  for {set j 0} {$j <= 7} {incr j} {variable FO$j; set FO$j 0}
  for {set j 0} {$j <= 7} {incr j} {variable PT$j; set PT$j 0}


    variable Rmsg
    variable Wmsg

    variable ModuleName v240
    variable ModuleMenu {}
    variable ModuleIndex 1

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg

             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag "
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"

         for {set i 0} {$i <= 7} {incr i} {variable II$i; InsertLog "II$i = [set II$i]"}
         for {set i 0} {$i <= 7} {incr i} {variable PT$i; InsertLog "PT$i = [set PT$i]"}
   }

   proc do_Button {reg} {InsertLog "Button $reg"

#    LR  Red LED
#    LG  Green LED
#      IE     Interrupts
#      IP     Interrupts
      
      variable $reg
      set $reg [expr ([set $reg] +1) & 1]

      switch $reg {
         LR  {WriteRegister Red [set $reg]}
         LG  {WriteRegister Green [set $reg]}
         IP  {WriteRegister Int.Pend [set $reg]}
         IE  {WriteRegister Int.Enable [set $reg]}
         default {InsertLog "do_Button  unexpected request $reg"}
      }
   }

    proc UpdateModule {} {

        for {set i 0} {$i <= 7} {incr i} {variable P$i; set P$i [expr [ReadRegister Port$i] & 4095]}

        for {set i 0} {$i <= 7} {incr i} {variable II$i; set II$i [expr [ReadRegister II$i] & 1]}
        for {set i 0} {$i <= 7} {incr i} {variable IM$i; set IM$i [expr [ReadRegister IM$i] & 1]}
        for {set i 0} {$i <= 7} {incr i} {variable IP$i; set IP$i [expr [ReadRegister IP$i] & 1]}
        for {set i 0} {$i <= 7} {incr i} {variable IC$i; set IC$i [expr [ReadRegister IC$i] & 1]}
        for {set i 0} {$i <= 7} {incr i} {variable FO$i; set FO$i [expr [ReadRegister FO$i] & 1]}
        for {set i 0} {$i <= 7} {incr i} {variable PT$i; set PT$i [expr [ReadRegister PT$i] & 1]}

        variable IV; set IV [expr [ReadRegister Int.Vector]]
        variable LR; set LR [expr [ReadRegister Red] & 1]
        variable LG; set LG [expr [ReadRegister Green] & 1]
        variable IP; set IP [expr [ReadRegister Int.Pend] & 1]
        variable IE; set IE [expr [ReadRegister Int.Enable] & 1]
   }

     proc do_Setting {w} {InsertLog "Setting $w"

        variable $w
        set $w [expr ([set $w] +1) & 1]

       switch -glob $w {
         II*  {WriteRegister $w [set $w]}
         IM*  {WriteRegister $w [set $w]}
         IP*  {WriteRegister $w [set $w]}
         IC*  {WriteRegister $w [set $w]}
         FO*  {WriteRegister $w [set $w]}
         default {InsertLog "do_Setting  unexpected request $w"}
       }
     }

     proc do_Port {w vl} {InsertLog "Port $w $vl"

        variable $w
        set $w $vl

       switch -glob $w {
         PT*  {WriteRegister $w [set $w]}
         default {InsertLog "do_Port  unexpected request $w"}
       }
     }

     proc do_IVec {vl} {InsertLog "IVec  $vl"

         variable IV; set IV $vl

         WriteRegister Int.Vector $IV
     }

     proc do_HardwareReset {} {WriteRegister Reset 1; WriteRegister Reset 0}

    proc do_Save {which} {
        variable ModuleName
        variable ModuleIndex

           InsertLog "Saving Settings for [set ModuleName]#[set ModuleIndex]"
    }

    proc do_Restore {which} {
        variable ModuleName
        variable ModuleIndex

           InsertLog "Restoring Settings for [set ModuleName]#[set ModuleIndex]"
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   PORT   {do_Port [lindex $w 1] [lindex $w 2]}
                   PDATA  {do_Setting [lindex $w 1]}
                   IVEC   {do_IVec [lindex $w 1]}
                   BUTTON   {do_Button [lindex $w 1]}

                   HDWRE     {do_HardwareReset}

                   REDISPLAY  {UpdateModule} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

    UpdateModule

}   ;# end of if {$started == 0}

