

# variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag
     variable ModuleIndex

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

#     do_Select $ModuleIndex

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1


    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable allmodules 0
  
    variable P0  "VMEIDXYC560    1"
    variable P1 0
    variable P2 0
    variable P3 0
    variable P4 0
    variable P5 0
    variable P6 0
    variable P7 0

    variable Ch0 0
    variable Ch1 0
    variable Ch2 0
    variable Ch3 0
    variable Ch4 0
    variable Ch5 0
    variable Ch6 0
    variable Ch7 0

    variable Rmsg
    variable Wmsg

    variable ModuleName v560
    variable ModuleMenu {}
    variable ModuleIndex 1

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg
    variable P0
    variable P1
    variable P2
    variable P3
    variable P4
    variable P5
    variable P6
    variable P7
    variable P8
    variable P9

             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag "
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"

         InsertLog "P1 = $P1; P2 = $P2; P3 = $P3; P4 = $P4"
         InsertLog "P5 = $P5; P6 = $P6; P7 = $P7; P8 = $P8; P9 = $P9"

       for {set i 0} {$i < 8} {incr i} {variable Ch$i; InsertLog "Ch$i = [set Ch$i]"}

   }

   proc do_Setting {reg vl} {InsertLog "Setting $reg $vl"

#      P1     Vector
#      P2     Mode
#      P3     Gain
#      P4     Channel
#      P5     Data

      variable $reg
      set $reg $vl

      switch $reg {
         P1  {WriteRegister Int.Vector [set $reg]}
         P2  {WriteRegister Mode [set $reg]}
         P3  {WriteRegister Gain [set $reg]}
         P4  {WriteRegister Channel [set $reg]}
         P5  {}
         default {InsertLog "do_Setting  unexpected request $reg"}
      }
   }

   proc do_Button {reg} {InsertLog "Button $reg"

#    P6  Red LED
#    P7  Green LED
#      P8     Interrupts
#      P9     Interrupts
      
      variable $reg
      set $reg [expr ([set $reg] +1) & 1]

      switch $reg {
         P6  {WriteRegister Red [set $reg]}
         P7  {WriteRegister Green [set $reg]}
         P8  {WriteRegister Int.Pend [set $reg]}
         P9  {WriteRegister Int.Enable [set $reg]}
         default {InsertLog "do_Button  unexpected request $reg"}
      }

   }
 
    proc UpdateModule {} {

        for {set i 0} {$i < 8} {incr i} {variable Ch$i; set Ch$i [expr [ReadRegister Channel$i] & 4095]}

        variable P2; set P2 [expr [ReadRegister Mode] & 3]
        variable P3; set P3 [expr [ReadRegister Gain] & 3]
        variable P4; set P4 [expr [ReadRegister Channel] & 63]
        variable P5; set P5 [expr [ReadRegister Data] & 0x0fff]
        variable P6; set P6 [expr [ReadRegister Red] & 1]
        variable P7; set P7 [expr [ReadRegister Green] & 1]
        variable P8; set P8 [expr [ReadRegister Int.Pend] & 1]
        variable P9; set P9 [expr [ReadRegister Int.Enable] & 1]

   }

     proc do_Convert {} {WriteRegister Convert 1}

     proc do_HardwareReset {} {WriteRegister Reset 1; WriteRegister Reset 0}

    proc do_Save {which} {
        variable ModuleName
        variable ModuleIndex

           InsertLog "Saving Settings for [set ModuleName]#[set ModuleIndex]"
    }

    proc do_Restore {which} {
        variable ModuleName
        variable ModuleIndex

           InsertLog "Restoring Settings for [set ModuleName]#[set ModuleIndex]"
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   SETTING  {do_Setting [lindex $w 1] [lindex $w 2]}
                   BUTTON   {do_Button [lindex $w 1]}

                   HDWRE     {do_HardwareReset}
                   CONVERT   {do_Convert}

                   REDISPLAY  {UpdateModule} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

    UpdateModule

}   ;# end of if {$started == 0}

