

#variable started 0

if {![info exists started]} {variable started 0}

if {$started != 0} {

     variable JS ""
     variable LogFlag
     variable ModuleIndex

     if {$LogFlag == 1} {InsertLog "Last Updated: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}

#     do_Select $ModuleIndex

    do_click
}

if {$started == 0} {           ;#  first time load code and define local variables
    set started 1    

    set Color1(0) Red
    set Color1(1) Green
    set Color2(0) Blue
    set Color2(1) #D4A017     ;# Orange Gold

    variable LogText ""
    variable LogFlag 0
    variable LogCount 0

    variable ShowLogFlag 0

    variable JS ""

    variable X 0
    variable Y 0
    variable Z 0
    variable T 0
    variable U 0
    variable V 0

    variable Axis "X"
    variable Command "undefined"

    variable Rmsg
    variable Wmsg

    variable ModuleName maxv6000
    variable ModuleMenu {}
    variable ModuleIndex 1

     if {$LogFlag == 1} {InsertLog "Started: [clock format [clock seconds] -format "%B %d, %Y %H:%M:%S"]"}


   proc show_variables {} {
        variable LogFlag
        variable ShowLogFlag
        variable Rmsg
        variable Wmsg

             InsertLog "LogFlag=$LogFlag; ShowLogFlag=$ShowLogFlag "
             InsertLog "Rmsg=$Rmsg"
             InsertLog "Wmsg=$Wmsg"
   }

    proc UpdateModule {} {}

     proc do_AXIS {vl} {   ;#InsertLog "AXIS=$vl"
        variable X 
        variable Y 
        variable Z 
        variable T 
        variable U 
        variable V 

         switch $vl {
            0   {set X 1; set Y 0; set Z 0; set T 0; set U 0; set V 0}
            1   {set X 0; set Y 1; set Z 0; set T 0; set U 0; set V 0}
            2   {set X 0; set Y 0; set Z 1; set T 0; set U 0; set V 0}
            3   {set X 0; set Y 0; set Z 0; set T 1; set U 0; set V 0}
            4   {set X 0; set Y 0; set Z 0; set T 0; set U 1; set V 0}
            5   {set X 0; set Y 0; set Z 0; set T 0; set U 0; set V 1}
         }
     }

     proc do_COMMAND {vl} {    ;#InsertLog "COMMAND $vl"
        variable Cmd
        set Cmd $vl
     }

     proc do_KILL {w} {InsertLog "KILL"
#    direct mail box command 2 is KILL_ALL_MOTION
        WriteRegister CommandMailbox 2
     }

     proc do_WO {} {InsertLog "WO"
          variable Axis
          variable Cmd
         WriteRegister $Axis.Command.WriteOnly $Cmd
     }

     proc do_RW {} {   ;#InsertLog "RW"
          variable Axis
          variable Cmd
         WriteRegister $Axis.Command.WriteRead $Cmd
         set rc [ReadRegister $Axis.Command.WriteRead]
         InsertLog "$Cmd => $rc"
     }

    proc do_Save {which} {
        variable ModuleName
        variable ModuleIndex

           InsertLog "Saving Settings for [set ModuleName]#[set ModuleIndex]"
    }

    proc do_Restore {which} {
        variable ModuleName
        variable ModuleIndex

           InsertLog "Restoring Settings for [set ModuleName]#[set ModuleIndex]"
    }

     proc do_click {} {
       variable cgidata
       variable started
       variable LogFlag
       variable ShowLogFlag

       set cgidata [ncgi::nvlist]

       if {$LogFlag == 1} {InsertLog "cgidata= ([llength $cgidata]) $cgidata"}

       if {[llength $cgidata] == 0} then {return}

       if {[llength $cgidata] < 2} then {
           InsertLog "CGI data is too short: $cgidata"
       } else {
           if {[lindex $cgidata 0] != "Widget"} then {
               InsertLog "Invalid CGI data: $cgidata"
           } else {
               set w [lindex $cgidata 1]

               switch -glob [lindex $w 0] {

                   RESET    {set started 0}
                   CLEAR    {EmptyLog}
                   ELOG     {PrintLog}
                   RELOAD   {}
                   VARIABLES {show_variables}

                   HIDE     {set ShowLogFlag 0}
                   SHOW     {set ShowLogFlag 1}
                   LOGON    {set LogFlag 1}
                   LOGOFF   {set LogFlag 0}

                   AXIS   {do_AXIS [lindex $w 1]}
                   COMMAND {do_COMMAND [lindex $w 1]}

                   KILL   {do_KILL}
                   WO     {do_WO}
                   RW     {do_RW}

                   REDISPLAY  {UpdateModule} 

                   MainLog {}
                   undefined {}
                   default {InsertLog "unexpected CGI data: [lindex $w 0]: $cgidata"}
               }
           }
       }
       UpdateModule
    }

    UpdateModule

}   ;# end of if {$started == 0}

