

    set A32Base [third [split $AddressData :]]


DefineRegister $Module xVME Firmware_Rev  "-a $A32Base -w 32 -o 0x800c -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME GEO_Address   "-a $A32Base -w 32 -o 0x8008 -p ro -d 16 -l 5 -b 0 -z x"
DefineRegister $Module xVME Reset         "-a $A32Base -w 32 -o 0x800a -p wo -d 16 -l 0 -b 0"
DefineRegister $Module xVME VMEStatus     "-a $A32Base -w 32 -o 0xef04 -p ro -d 32 -l 3 -b 0 -z x"

DefineRegister $Module xVME ROM.OUI_MSB   "-a $A32Base -w 32 -o 0x8124 -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.OUI       "-a $A32Base -w 32 -o 0x8128 -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.OUI_LSB   "-a $A32Base -w 32 -o 0x812c -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.Version   "-a $A32Base -w 32 -o 0x8130 -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.BID_MSB   "-a $A32Base -w 32 -o 0x8134 -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.BID       "-a $A32Base -w 32 -o 0x8138 -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.BID_LSB   "-a $A32Base -w 32 -o 0x813c -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.Rev       "-a $A32Base -w 32 -o 0x804c -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.Ser_MSB   "-a $A32Base -w 32 -o 0x8180 -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME ROM.Ser_LSB   "-a $A32Base -w 32 -o 0x8184 -p ro -d 16 -l 0 -b 0 -z x"

DefineRegister $Module xVME UserConfig    "-a $A32Base -w 32 -o 0x8016 -p rw -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME UserFlashSel  "-a $A32Base -w 32 -o 0x8012 -p rw -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME UserFlashMem  "-a $A32Base -w 32 -o 0x8014 -p rw -d 16 -l 0 -b 0 -z x"

DefineRegister $Module xVME FlashData     "-a $A32Base -w 32 -o 0x8014 -p ro -d 16 -l 0 -b 0 -z x"

DefineRegister $Module xVME Scratch16     "-a $A32Base -w 32 -o 0x8018 -p rw -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME Arm           "-a $A32Base -w 32 -o 0x8018 -p rw -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME Scratch32     "-a $A32Base -w 32 -o 0x8020 -p rw -d 32 -l 0 -b 0 -z x"

DefineRegister $Module xVME DataItem      "-a $A32Base -w 32 -o 0x0 -p ro -d 32 -l 0 -b 0 -z x"
DefineRegister $Module bVME DataBuffer    "-a $A32Base -w 32 -o 0x0 -p ro -d 32 -z x -l 64"

DefineRegister $Module xVME FPGAItem      "-a $A32Base -w 32 -o 0x1000 -p rw -d 32 -l 0 -b 0 -z x"
DefineRegister $Module bVME FPGABuffer    "-a $A32Base -w 32 -o 0x1000 -p rw -d 32 -z x -l 64"

DefineRegister $Module xVME Version      "-a $A32Base -w 32 -o 0x103c -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME InputPort1   "-a $A32Base -w 32 -o 0x1010 -p ro -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME InputPort2   "-a $A32Base -w 32 -o 0x1014 -p ro -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME InputPort3   "-a $A32Base -w 32 -o 0x1018 -p ro -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME OutputPort1  "-a $A32Base -w 32 -o 0x101c -p ro -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME OutputPort2  "-a $A32Base -w 32 -o 0x1020 -p ro -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME OutputPort3  "-a $A32Base -w 32 -o 0x1024 -p ro -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME IDD          "-a $A32Base -w 32 -o 0x1028 -p ro -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME IDE          "-a $A32Base -w 32 -o 0x102c -p ro -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME IDF          "-a $A32Base -w 32 -o 0x1030 -p ro -d 32 -l 0 -b 0 -z x"

DefineRegister $Module xVME Ctrl         "-a $A32Base -w 32 -o 0x1040 -p rw -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME Config.B0    "-a $A32Base -w 32 -o 0x1040 -p rw -d 32 -l 2 -b 0 -z d"
DefineRegister $Module xVME Config.B2    "-a $A32Base -w 32 -o 0x1040 -p rw -d 32 -l 1 -b 2 -z d"
DefineRegister $Module xVME Config.B3    "-a $A32Base -w 32 -o 0x1040 -p rw -d 32 -l 1 -b 3 -z d"
DefineRegister $Module xVME Config.B4    "-a $A32Base -w 32 -o 0x1040 -p rw -d 32 -l 1 -b 4 -z d"
DefineRegister $Module xVME Config.B7    "-a $A32Base -w 32 -o 0x1040 -p rw -d 32 -l 1 -b 7 -z d"
DefineRegister $Module xVME Config.B8    "-a $A32Base -w 32 -o 0x1040 -p rw -d 32 -l 1 -b 8 -z d"
DefineRegister $Module xVME Config.B9    "-a $A32Base -w 32 -o 0x1040 -p rw -d 32 -l 1 -b 9 -z d"

DefineRegister $Module xVME InputMask1   "-a $A32Base -w 32 -o 0x1044 -p rw -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME InputMask2   "-a $A32Base -w 32 -o 0x1048 -p rw -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME InputMask3   "-a $A32Base -w 32 -o 0x104c -p rw -d 32 -l 0 -b 0 -z x"

DefineRegister $Module xVME UserValue1   "-a $A32Base -w 32 -o 0x1050 -p rw -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME UserValue2   "-a $A32Base -w 32 -o 0x1054 -p rw -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME UserValue3   "-a $A32Base -w 32 -o 0x1058 -p rw -d 32 -l 0 -b 0 -z x"
DefineRegister $Module xVME UserValue4   "-a $A32Base -w 32 -o 0x105c -p rw -d 32 -l 0 -b 0 -z x"

#    Centrum Interface
DefineRegister $Module xVME MODE       "-a $A32Base -w 32 -o 0x101e -p rw -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME STATUS2    "-a $A32Base -w 32 -o 0x10c6 -p ro -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME STATUS3    "-a $A32Base -w 32 -o 0x10c8 -p ro -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME STATUS4    "-a $A32Base -w 32 -o 0x10ca -p ro -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME STATUS5    "-a $A32Base -w 32 -o 0x10cc -p ro -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME STATUS6    "-a $A32Base -w 32 -o 0x10ce -p ro -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME STATUS7    "-a $A32Base -w 32 -o 0x10d0 -p ro -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME STATUS8    "-a $A32Base -w 32 -o 0x10d2 -p ro -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME MIS4       "-a $A32Base -w 32 -o 0x10d6 -p rw -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME MIS5       "-a $A32Base -w 32 -o 0x10d8 -p rw -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME MIS2       "-a $A32Base -w 32 -o 0x10da -p rw -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME INSPECT    "-a $A32Base -w 32 -o 0x10de -p rw -d 16 -l 0 -b 0 -z d"

#    Trigger
DefineRegister $Module xVME CNTOK_L       "-a $A32Base -w 32 -o 0x1074 -p ro -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME CNTOK_H       "-a $A32Base -w 32 -o 0x1076 -p ro -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME CNTOKN_L      "-a $A32Base -w 32 -o 0x1078 -p ro -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME CNTOKN_H      "-a $A32Base -w 32 -o 0x107a -p ro -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME CNTFA_L       "-a $A32Base -w 32 -o 0x107c -p ro -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME CNTFA_H       "-a $A32Base -w 32 -o 0x107e -p ro -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME CNTMUX1_L     "-a $A32Base -w 32 -o 0x1080 -p ro -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME CNTMUX1_H     "-a $A32Base -w 32 -o 0x1082 -p ro -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME CNTMUX2_L     "-a $A32Base -w 32 -o 0x1084 -p ro -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME CNTMUX2_H     "-a $A32Base -w 32 -o 0x1086 -p ro -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME RAZCNT        "-a $A32Base -w 32 -o 0x1090 -p rw -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME ENCNT         "-a $A32Base -w 32 -o 0x1092 -p rw -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME TESTD32       "-a $A32Base -w 32 -o 0x1094 -p rw -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME MUX1          "-a $A32Base -w 32 -o 0x108c -p rw -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME MUX2          "-a $A32Base -w 32 -o 0x108e -p rw -d 16 -l 0 -b 0 -z d"

#    FT Trigger
DefineRegister $Module xVME FT_CTRL           "-a $A32Base -w 32 -o 0x10e0 -p rw -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME FT_RDOUT_STATUS   "-a $A32Base -w 32 -o 0x10e2 -p rw -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME FT_RDOUT_CTRL     "-a $A32Base -w 32 -o 0x10e4 -p rw -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME FT_RUN            "-a $A32Base -w 32 -o 0x10e6 -p rw -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME GATE_W            "-a $A32Base -w 32 -o 0x10e8 -p rw -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME FT_RDOUT_DELAY    "-a $A32Base -w 32 -o 0x10ec -p rw -d 16 -l 0 -b 0 -z d"
DefineRegister $Module xVME PreScaleReg       "-a $A32Base -w 32 -o 0x10ee -p rw -d 16 -l 0 -b 0 -z d"

DefineRegister $Module xVME FP_Test       "-a $A32Base -w 32 -o 0x1200 -p rw -d 16 -l 0 -b 0 -z x"
DefineRegister $Module xVME DATE          "-a $A32Base -w 32 -o 0x10ea -p ro -d 16 -l 0 -b 0 -z x"














puts "Defined $Module"
